OptParse: Short style switch with range does not work

05/30/2016 03:41 PM - vo.x (Vit Ondruch)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.1p112 (2016-04-26 revision

54768) [x86_64-linux]

Backport: 2.1: WONTFIX, 2.2: DONE, 2.3: DONE

Description

This does not seems to be working:

$ irb

irb(main):001:0> require 'optparse'

irb(main):002:0> o = OptionParser.new

irb(main):003:0> o.on('-[a-z]') {}

irb(main):004:0> o.parse('-f')

NoMethodError: undefined method `size' for nil:NilClass

 from /usr/share/ruby/optparse.rb:433:in `block in complete'

 from /usr/share/ruby/optparse.rb:433:in `each'

 from /usr/share/ruby/optparse.rb:433:in `sort_by'

 from /usr/share/ruby/optparse.rb:433:in `complete'

 from /usr/share/ruby/optparse.rb:838:in `complete'

 from /usr/share/ruby/optparse.rb:1694:in `block in visit'

 from /usr/share/ruby/optparse.rb:1693:in `reverse_each'

 from /usr/share/ruby/optparse.rb:1693:in `visit'

 from /usr/share/ruby/optparse.rb:1725:in `block in complete'

 from /usr/share/ruby/optparse.rb:1724:in `catch'

 from /usr/share/ruby/optparse.rb:1724:in `complete'

 from /usr/share/ruby/optparse.rb:1553:in `block in parse_in_order'

 from /usr/share/ruby/optparse.rb:1527:in `catch'

 from /usr/share/ruby/optparse.rb:1527:in `parse_in_order'

 from /usr/share/ruby/optparse.rb:1521:in `order!'

 from /usr/share/ruby/optparse.rb:1613:in `permute!'

 from /usr/share/ruby/optparse.rb:1635:in `parse!'

 from /usr/share/ruby/optparse.rb:1624:in `parse'

 from (irb):4

 from /usr/bin/irb:11:in `<main>'

 Although it is not clear from the documentation, I'd expect that this should match every short option, but unfortunately, it does not

work at all ...

Associated revisions

Revision dd1be236d982b660cae84c1b0ea42f2869c102ad - 05/31/2016 08:28 AM - nobu (Nobuyoshi Nakada)

optparse.rb: fix char class option

lib/optparse.rb (OptionParser::Completion.candidate): get rid of

nil as key names.  [ruby-core:75773] [Bug #12438]

lib/optparse.rb (OptionParser#make_switch): char class option

cannot be NoArgument, default to RequiredArgument.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55228 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision dd1be236 - 05/31/2016 08:28 AM - nobu (Nobuyoshi Nakada)

optparse.rb: fix char class option

lib/optparse.rb (OptionParser::Completion.candidate): get rid of

nil as key names.  [ruby-core:75773] [Bug #12438]

lib/optparse.rb (OptionParser#make_switch): char class option

cannot be NoArgument, default to RequiredArgument.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55228 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2c490bea5b4eb31ae20386bc88d46d2ff432f407 - 06/10/2016 08:49 AM - U.Nakamura 

merge revision(s) 55228: [Backport #12438]

    * lib/optparse.rb (OptionParser::Completion.candidate): get rid of

      nil as key names.  [ruby-core:75773] [Bug #12438]

    * lib/optparse.rb (OptionParser#make_switch): char class option

      cannot be NoArgument, default to RequiredArgument.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@55364 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2c490bea - 06/10/2016 08:49 AM - U.Nakamura 

merge revision(s) 55228: [Backport #12438]

    * lib/optparse.rb (OptionParser::Completion.candidate): get rid of

      nil as key names.  [ruby-core:75773] [Bug #12438]

    * lib/optparse.rb (OptionParser#make_switch): char class option

      cannot be NoArgument, default to RequiredArgument.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@55364 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a11bb4fa91f520847afcdc6e56b44a904564f4d9 - 06/19/2016 05:47 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 55228: [Backport #12438]

    * lib/optparse.rb (OptionParser::Completion.candidate): get rid of

      nil as key names.  [ruby-core:75773] [Bug #12438]

    * lib/optparse.rb (OptionParser#make_switch): char class option

      cannot be NoArgument, default to RequiredArgument.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@55459 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a11bb4fa - 06/19/2016 05:47 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 55228: [Backport #12438]

    * lib/optparse.rb (OptionParser::Completion.candidate): get rid of

      nil as key names.  [ruby-core:75773] [Bug #12438]

    * lib/optparse.rb (OptionParser#make_switch): char class option

      cannot be NoArgument, default to RequiredArgument.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@55459 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/31/2016 08:28 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r55228.

optparse.rb: fix char class option

lib/optparse.rb (OptionParser::Completion.candidate): get rid of

nil as key names.  [ruby-core:75773] [Bug #12438]

lib/optparse.rb (OptionParser#make_switch): char class option

cannot be NoArgument, default to RequiredArgument.

#2 - 06/08/2016 05:48 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: WONTFIX, 2.2: REQUIRED, 2.3: REQUIRED

#3 - 06/10/2016 08:49 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: WONTFIX, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: WONTFIX, 2.2: DONE, 2.3: REQUIRED

ruby_2_2 r55364 merged revision(s) 55228.
#4 - 06/19/2016 05:47 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: WONTFIX, 2.2: DONE, 2.3: REQUIRED to 2.1: WONTFIX, 2.2: DONE, 2.3: DONE

ruby_2_3 r55459 merged revision(s) 55228.
